// Programmer (Icon).. Akasha (Myloth)
// Created 9-23-2003
// www.uoshardnow.d2gwebsite.com
// (above is origonal writer of this script which was "a Elite Vampire")
// I only take credit for the imagination to create something else out of it.
// GoldDraco13 Dragons of Pern =]
using System; 
using System.Collections; 
using Server.Items; 

namespace Server.Mobiles 
{ 
   [CorpseName( "a neptune rider's corpse" )] 
   public class NeptuneRider : BaseCreature 
   { 
      [Constructable] 
      public NeptuneRider() : base( AIType.AI_Mage, FightMode.Closest, 15, 1, 0.2, 0.4 ) 
      { 
         Body = 0x190; 
         Name = "a neptune rider"; 
         Hue = 1152; 
         BaseSoundID = 1200; 

         SetStr( 416, 505 ); 
         SetDex( 296, 315 ); 
         SetInt( 1966, 5045 ); 

         SetHits( 960, 995 ); 

         SetDamage( 15, 27 ); 

         SetDamageType( ResistanceType.Physical, 10 ); 
         SetDamageType( ResistanceType.Cold, 40 ); 
         SetDamageType( ResistanceType.Energy, 100 ); 

         SetResistance( ResistanceType.Physical, 85, 95 ); 
         SetResistance( ResistanceType.Fire, 100 ); 
         SetResistance( ResistanceType.Cold, 50, 60 ); 
         SetResistance( ResistanceType.Poison, 50, 60 ); 
         SetResistance( ResistanceType.Energy, 5, 10 ); 

         SetSkill( SkillName.EvalInt, 120.1, 130.0 ); 
         SetSkill( SkillName.Magery, 120.0, 130.0 ); 
         SetSkill( SkillName.Meditation, 100.0, 120.0 ); 
         SetSkill( SkillName.Poisoning, 100.0, 110.0 ); 
         SetSkill( SkillName.MagicResist, 175.0, 200.0 ); 
         SetSkill( SkillName.Tactics, 90.0, 100.0 ); 
         SetSkill( SkillName.Wrestling, 120, 130.0 ); 
        
        SeaHorse mare = new SeaHorse();
        mare.Rider = this;
                                                  
         Fame = 230000; 
         Karma = -230000; 

         VirtualArmor = 80;
	 CanSwim = true; 

                        AddItem( new Boots( Utility.RandomNeutralHue() ) ); 
                        AddItem( new Robe() );
      			
                        
         Item hair = new Item( Utility.RandomList( 0x203B, 0x2049, 0x2048, 0x204A ) ); 
         hair.Hue = 1153; 
         hair.Layer = Layer.Hair; 
         hair.Movable = false; 
         AddItem( hair ); 
                           
                                                                                
         PackGold( 4000,7500 ); 


          switch ( Utility.Random( 50 )) 
          { 
            case 0: PackItem( new Katana() ); break; 
            case 1: PackItem( new Axe() ); break; 
            default: break; 
          } 
}    
            
      
      public override bool AutoDispel{ get{ return true; } } 
      public override bool AlwaysMurderer{ get{ return true; } } 
      public override Poison PoisonImmune{ get{ return Poison.Deadly; } } 
      public override int TreasureMapLevel{ get{ return 5; } } 
      public override bool BardImmune{ get{ return true; } } 
      
    
      public NeptuneRider( Serial serial ) : base( serial ) 
      { 
      } 

      public override void Serialize( GenericWriter writer ) 
      { 
         base.Serialize( writer ); 
         writer.Write( (int) 0 ); 
      } 

      public override void Deserialize( GenericReader reader ) 
      { 
         base.Deserialize( reader ); 
         int version = reader.ReadInt(); 
      } 
         public void SpawnWalkableDeepSeaSerpent( Mobile m ) 
      { 
         Map map = this.Map; 

         if ( map == null ) 
            return; 

         WalkableDeepSeaSerpent spawned = new WalkableDeepSeaSerpent(); 

         spawned.Team = this.Team; 
         spawned.Map = map; 

         bool validLocation = false; 

         for ( int j = 0; !validLocation && j < 10; ++j ) 
         { 
            int x = X + Utility.Random( 3 ) - 1; 
            int y = Y + Utility.Random( 3 ) - 1; 
            int z = map.GetAverageZ( x, y ); 

            if ( validLocation = map.CanFit( x, y, this.Z, 16, false, false ) ) 
               spawned.Location = new Point3D( x, y, Z ); 
            else if ( validLocation = map.CanFit( x, y, z, 16, false, false ) ) 
               spawned.Location = new Point3D( x, y, z ); 
         } 

         if ( !validLocation ) 
            spawned.Location = this.Location; 

         spawned.Combatant = m; 
      } 

      public void EatWalkableDeepSeaSerpents() 
      { 
         Map map = this.Map; 

         if ( map == null ) 
            return; 

         ArrayList toEat = new ArrayList(); 

         IPooledEnumerable eable = map.GetMobilesInRange( this.Location, 2 ); 
  
         foreach ( Mobile m in eable ) 
         { 
            if ( m is WalkableDeepSeaSerpent ) 
               toEat.Add( m ); 
         } 

         eable.Free(); 

         if ( toEat.Count > 0 ) 
         { 
            PlaySound( Utility.Random( 0x3B, 2 ) ); // Eat sound 

            foreach ( Mobile m in toEat ) 
            { 
               Hits += (m.Hits / 2); 
               m.Delete(); 
            } 
         } 
      } 

      public override void OnGotMeleeAttack( Mobile attacker ) 
      { 
         base.OnGotMeleeAttack( attacker ); 

         if ( this.Hits > (this.HitsMax / 4) ) 
         { 
            if ( 0.25 >= Utility.RandomDouble() ) 
               	SpawnWalkableDeepSeaSerpent( attacker ); 
         } 
         else if ( 0.25 >= Utility.RandomDouble() ) 
         { 
            EatWalkableDeepSeaSerpents(); 
         } 
      } 
   } 
} 
